<template>
  <q-card-section class="col-12 text-center">
    <div class="text-h6 text-terciary">Membres</div>
    <div class="text-subtitle2 text-terciary">
      Breu descripció dels membres <span v-if="name">de: {{ name }}</span>
    </div>
  </q-card-section>
  <q-card-section class="col-12 col-md-10 offset-md-1 justfy-center row">
    <q-card-section class="col-12 col-md-4 q-py-md">
      <q-uploader
        square
        flat
        bordered
        class="full-width"
        :label="`Fotos de${labelUpload}`"
        auto-upload
        url="http://localhost:4444/upload"
        multiple
      />
    </q-card-section>

    <!-- Form -->
    <q-card-section class="col-12 col-md-3 no-padding">
      <q-card-section>
        <q-input square outlined v-model="form.name" type="text" label="Nom*" />
      </q-card-section>
      <q-card-section>
        <q-input
          square
          outlined
          v-model.number="form.age"
          type="number"
          label="Edat *"
        />
      </q-card-section>
      <q-card-section>
        <q-select
          emit-value
          square
          outlined
          v-model="form.gender"
          label="Gènere"
          :options="GENDERS"
        />
      </q-card-section>
      <q-card-section>
        <q-input
          square
          outlined
          v-model="form.profession"
          type="text"
          label="Ofici"
        />
      </q-card-section>
      <!-- ADD MEMBER -->
      <q-card-section class="row col-12 justify-center">
        <q-btn
          unelevated
          square
          color="primary"
          icon="add"
          label="Afegeix membre"
          @click="addMember"
          :disable="!form.name || !form.age"
        />
      </q-card-section>
    </q-card-section>

    <!-- Members -->
    <q-card-section class="col-12 col-md-5 q-py-md ">
      <q-list separator>
        <q-item v-for="(member, index) in members" :key="index">
          <q-item-section avatar>
            {{ member.age }}
          </q-item-section>
          <q-item-section>
            {{ member.name }}
          </q-item-section>
          <q-item-section>
            {{ member.profession }}
          </q-item-section>
          <q-item-section @click="removeMember(index)" avatar>
            <q-icon color="primary" :name="member.gender" />
          </q-item-section>
          <q-item-section @click="removeMember(index)" avatar>
            <q-icon color="red" name="clear" />
          </q-item-section>
        </q-item>
      </q-list>
    </q-card-section>
  </q-card-section>
</template>

<script setup>
import { ref, computed } from 'vue'
import { ProfileStore } from 'src/stores/profileStore'
import { storeToRefs } from 'pinia'

const profile = ProfileStore()
const { members, photos, name } = storeToRefs(profile)

const GENDERS = [
  {
    label: 'Dona',
    value: 'female'
  },
  {
    label: 'Home',
    value: 'male'
  },
  {
    label: 'Altres',
    value: 'transgender'
  }
]

const form = ref({})
photos.value = []

/***********************/
/* @Methods:
 ************************/
const addMember = () => {
  members.value.push(form.value)
  form.value = {}
}

const removeMember = index => {
  members.value.splice(index, 1)
}

/***********************/
/* @Computed:
 ************************/
const labelUpload = computed(() => {
  return profile.profiletype === 'uc'
    ? ' la Unitat de Convivència'
    : 'ls membres del Projecte'
})
</script>
